#include <iostream>
#include "rect.h"
#include <assert.h>
#include "bitmap.h"
SimpleWindow w("Keyboard",28.0,21.0);
char ar[30],posno=-1;
float X=1.0,Y=2.0,xcor=0.0;
enum caps {on,off};
caps capslock=off;
using namespace std;
const char ch[40][2]={"1","2","3","4","5","6","7","8","9","0",
		"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
		"S","B","C","E"};	
char GetChar(int);
void Draw_keyboard();
void Draw_keyboard()
{	int k=0;
	float b=w.GetWidth()/10;
	float h=w.GetHeight()/16;
	float x=0.0,y=w.GetHeight()*3/4;
	for(float j=y;j<=w.GetHeight()-h;j+=h)
	{	//if(j==y+h) ch='A';
		for(float i=x;i<=w.GetWidth()-b;i+=b)
		{	w.RenderRectangle(Position(i,j),Position(i+b,j+h),Blue,true);
			//if(!(j==y+3*h && i<=x+6*b))
			w.RenderText(Position(i+b/2,j+h/2),ch[k],Black);
			++k;
		}
	}  
}
int GetName(const Position &pos)
{	float x=pos.GetXDistance(),y=pos.GetYDistance();
	float b=w.GetWidth()/10;
	float h=w.GetHeight()/16;
	if(y>=w.GetHeight()*3/4)
	{	int coln=int(x/b)+1,rown=int((y-(w.GetHeight()*3/4))/h);
		int chart=10*rown+coln;
		
		if(chart==40)
		{	//nextpage();
		}		
		if(chart==38)
		{	if(posno>0) 
			{	ar[posno]='\0';
				--posno;
		 		w.RenderText(Position(X+xcor,Y),Position(X+xcor+0.5,Y+0.5)," ",Black);
				xcor-=0.5;
			}
		}
		else if(chart==37)
		{	++posno;xcor+=0.5;
			ar[posno]=32;
			w.RenderText(Position(X+xcor,Y),Position(X+xcor+0.5,Y+0.5)," ",Black);
		}
		else if(chart==39)
		{	if(capslock==off)capslock=on;
			else			 capslock=off;
		}
		else 
		{	if(posno<30)
			{	if(capslock==on) 
				{	++posno;xcor+=0.5;
					ar[posno]=GetChar(chart)-32;
				}
				else
				{	++posno;xcor+=0.5;
					ar[posno]=GetChar(chart);
				}
				w.RenderText(Position(X+xcor,Y),Position(X+xcor+0.5,Y+0.5),ch[chart-1],Black);
			}
		}
	}
	return 1;
}

char GetChar(int chart)
{	char ch1[41]="1234567890abcdefghijklmnopqrstuvwxyzSBCE";
	char cc=ch1[chart-1];
	return cc;
}
int ApiMain()
{	w.Open();
	Draw_keyboard();
	w.SetMouseClickCallback(GetName);
	return 0;		
}


