#include "ezwin.h"
#include <cassert>
#include "rect.h"

// Create a window with title "Terrain" at the beginning size 10cm x 10cm

SimpleWindow MyWindow("Terrain", 28.0, 21.0,
		      Position(0.0, 0.0));

// ApiMain(): create a window
int ApiMain()
{
  	MyWindow.Open();
  	assert(MyWindow.GetStatus() == WindowOpen);
		// Colors available with us: {White, Red, Green, Blue, Yellow, Cyan, Magenta};

  	//creating the background with sky as blue and terrain as green
	//sky
  	MyWindow.RenderRectangle(Position(0.0,0.0), Position(28.0,21.0),Blue, true);

  	//terrain
  	MyWindow.RenderRectangle(Position(0.0, 14.0), Position(28.0,21.0),Green, true);
 	MyWindow.RenderEllipse( Position(7.0,10.0),Position(21.0, 18.0),Green, false);
  	
	//creating the tanks of differnt colours
	MyWindow.RenderRectangle(Position(5.0,13.5), Position(5.5,14.0),Red, true);

	MyWindow.RenderRectangle(Position(18.0,13.5), Position(18.5,14.0),Magenta, true);

	return 0;
} 
//int ApiEnd()
//{
//	MyWindow.close();
//	return 0;
//}
